	; 
	; SAMPLE2.ASM - A simple demo
	;
	; *** Starting address
	;
	ORG $1001-2
	DW $1001

HorizPos 	= $E0  	; variables
ScrollCount	= $E1
;
ScrollPos	= $0F70	; Screen Position
	;
	; *** Produce one basic line
	;
	DW $100B,0
	DB $9E,"4109",0,0,0	; SYS4107
	
	;--- START
	;
	; ########################## INIT #########################
	;
	SEI		; DISABLE INTERRUPTS
	;
	JSR ClearScreen
	;
	STA $FF3F	; enable RAM
	;
	JSR WriteGreeting
	;
	; --- set up reset vector
	;
main
	LDX #main & 255	; low byte
	LDY #main >> 8	; and high byte of address
	STX $FFFC
	STY $FFFD
	;
	; --- set up nmi
	;
	LDX #irq & 255	; low byte
	LDY #irq >> 8	; and high byte of address
	STX $FFFE
	STY $FFFF
	;
	LDA #$AE
	STA $FF0B	; --- raster line
	;
	CLI
	;
main2
	LDA #$7F	; query keyboard
	STA $FD30
	STA $FF08
	LDA $FF08
	AND #$10	; check for space pressed
	BNE main2
	;
	; --- end of program
	;
	SEI
	STA $FF3E	; enable ROM
	JMP $FFF6	; reset
	;
	; ################ THE IRQ #################
	;	
irq
	PHA		; save A
	TXA
	PHA		; save X
	TYA
	PHA		; save Y
	;
	LDA $FF09	; clear interrupt bit
	STA $FF09
	;
	; (2) adjust horiz scroll TED register
	;
	LDA HorizPos	; *** get our VARIABLE ***
	STA $FF07	; change FF07 (horiz scroll)
	;
	; (3) do "rasterbar"
	;
	LDX #17		; 18 colors
	LDY #$A8	; VERTICAL POSITION check **
loop06	LDA Colors,x	; get next color
loop05	CPY $FF1E	; wait for vertical pos **
	BCS loop05	; keep waiting **
	;
	STA $FF19	; change BORDER and...
	STA $FF15	; background color
	DEX
	BPL loop06
	;
	; (4) restore color and scroll regs.
	;
	LDA #$08	; *** Return to "normal" horiz position
	STA $ff07
	;
	; (5) do the scroll work!
	;
	; --- increment scroll variable
	;
	LDX HorizPos	; get value of our variable
	DEX		; decrement by one
	BPL loop07	; positive? ( >= 0)
	;		; then that's it for this loop...
	;
	;     otherwise:
	; --- copy characters on screen
	;     only every 8th time
	;
	LDX #$00
loop08	LDA ScrollPos+1,X
	STA ScrollPos,X
	INX
	CPX #$27
	BNE loop08
	;
	; --- put NEW character onto screen
	;
	LDX ScrollCount
loop10	LDA ScrollText,X	; read scroll text
	CMP #$FF		; end flag?
	BNE loop09
	;
	LDX #$00		; restart from 0
	JMP loop10
	;
loop09	CMP #$40
	BCC put2
	AND #$1F
put2	STA ScrollPos+39	; LAST POSITION in our line
	INX			; next letter
	STX ScrollCount
	;
	LDX #$07	; next value
loop07	STX HorizPos	; store it
	;
	; --- end of IRQ
	;
	PLA
	TAY		; restore Y
	PLA
	TAX		; restore X
	PLA		; restore A
	RTI		; Return from Interrupt
	
ClearScreen
	;
	; --- clear the screen -----------------------------------------------------
	;
	LDX #$04	; Number of pages
	LDY #$08	; Hi byte of address ($0800)
	LDA #$09	; Byte to fill
	JSR $C5A7
	LDX #$04	; This clears the screen 
	LDY #$0C	; $0C00
	LDA #$20	; Space character 
	JSR $C5A7
	;
	RTS

WriteGreeting
	;
	; --- write greeting -------------------------------------------------------
	;
	LDX #greetinge-greeting-1	; number of characters to copy
loop04	LDA greeting,x	; read from data
	CMP #$40
	BCC put1
	AND #$1F
put1	STA $0d24,x	; put it on the screen
	LDA #$77	; color: yellow
	STA $0924,x
	DEX
	BPL loop04
	;
	LDX #message2e-message2-1	; number of characters to copy
loop04a	LDA message2,x	; read from data
	CMP #$40
	BCC put1a
	AND #$1F
put1a	STA $0d72,x	; put it on the screen
	LDA #$57	; color: yellow
	STA $0972,x
	DEX
	BPL loop04a
	;
	RTS
	
Colors
	DB $00
	DB $07,$17,$27,$37,$47,$57,$67,$77
	DB $71
	DB $79,$69,$59,$49,$39,$29,$19,$09
		
greeting
	DB "plus4ide example"
greetinge

message2
	DB "press space to exit."
message2e
	
ScrollText
	DB "hello everyone! "
	DB "csabo is proud to present "
	DB "this 1x1 scroller! "
	DB "it is achieved by adjusting the ff07 register "
	DB "and copying characters in the video memory... "
	DB "text will now restart... "
	DB $FF
	